---
title: outline-style
slug: Web/CSS/outline-style
tags:
  - CSS
  - CSS Outline
  - CSS Property
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>outline-style</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets the style of an element's outline. An outline is a line that is drawn around an element, outside the {{cssxref("border")}}.</p>

<div>{{EmbedInteractiveExample("pages/css/outline-style.html")}}</div>

<p>It is often more convenient to use the shorthand property {{cssxref("outline")}} when defining the appearance of an outline.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
outline-style: auto;
outline-style: none;
outline-style: dotted;
outline-style: dashed;
outline-style: solid;
outline-style: double;
outline-style: groove;
outline-style: ridge;
outline-style: inset;
outline-style: outset;

/* Global values */
outline-style: inherit;
outline-style: initial;
outline-style: unset;
</pre>

<p>The <code>outline-style</code> property is specified as any one of the values listed below.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt>
 <p><code>auto</code></p>
 </dt>
 <dd style="outline: 8px auto red;">Permits the user agent to render a custom outline style.</dd>
 <dt>
 <p><code>none</code></p>
 </dt>
 <dd>No outline is used. The {{cssxref("outline-width")}} is <code>0</code>.</dd>
 <dt>
 <p><code>dotted</code></p>
 </dt>
 <dd style="outline: 8px dotted red;">The outline is a series of dots.</dd>
 <dt>
 <p><code>dashed</code></p>
 </dt>
 <dd style="outline: 8px dashed red;">The outline is a series of short line segments.</dd>
 <dt>
 <p><code>solid</code></p>
 </dt>
 <dd style="outline: 8px solid red;">The outline is a single line.</dd>
 <dt>
 <p><code>double</code></p>
 </dt>
 <dd style="outline: 8px double red;">The outline is two single lines. The {{cssxref("outline-width")}} is the sum of the two lines and the space between them.</dd>
 <dt>
 <p><code>groove</code></p>
 </dt>
 <dd style="outline: 8px groove red;">The outline looks as though it were carved into the page.</dd>
 <dt>
 <p><code>ridge</code></p>
 </dt>
 <dd style="outline: 8px ridge red;">The opposite of <code>groove</code>: the outline looks as though it were extruded from the page.</dd>
 <dt>
 <p><code>inset</code></p>
 </dt>
 <dd style="outline: 8px inset red;">The outline makes the box look as though it were embedded in the page.</dd>
 <dt>
 <p><code>outset</code></p>
 </dt>
 <dd style="outline: 8px outset red;">The opposite of <code>inset</code>: the outline makes the box look as though it were coming out of the page.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_outline_style_to_auto">Setting outline style to auto</h3>

<p>The <code>auto</code> value indicates a custom outline style — <q cite="https://www.w3.org/TR/css-ui-3/#outline-style">typically a style [that] is either a user interface default for the platform, or perhaps a style that is richer than can be described in detail in CSS, e.g. a rounded edge outline with semi-translucent outer pixels that appears to glow.</q></p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;p class="auto"&gt;Outline Demo&lt;/p&gt;
&lt;/div&gt; </pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">.auto {
  outline-style: auto; /* same result as "outline: auto" */
}

/* To make the Demo clearer */
* { outline-width: 10px; padding: 15px; } </pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Setting_outline_style_to_auto') }}</p>

<h3 id="Setting_outline_style_to_dashed_and_dotted">Setting outline style to dashed and dotted</h3>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;div class="dotted"&gt;
    &lt;p class="dashed"&gt;Outline Demo&lt;/p&gt;
  &lt;/div&gt;
&lt;/div&gt; </pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">.dotted {
  outline-style: dotted; /* same result as "outline: dotted" */
}
.dashed {
  outline-style: dashed;
}

/* To make the Demo clearer */
* { outline-width: 10px; padding: 15px; } </pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Setting_outline_style_to_dashed_and_dotted') }}</p>

<h3 id="Setting_outline_style_to_solid_and_double">Setting outline style to solid and double</h3>

<h4 id="HTML_3">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;div class="solid"&gt;
    &lt;p class="double"&gt;Outline Demo&lt;/p&gt;
  &lt;/div&gt;
&lt;/div&gt; </pre>

<h4 id="CSS_3">CSS</h4>

<pre class="brush: css notranslate">.solid {
  outline-style: solid;
}
.double {
  outline-style: double;
}

/* To make the Demo clearer */
* { outline-width: 10px; padding: 15px; } </pre>

<h4 id="Result_3">Result</h4>

<p>{{ EmbedLiveSample('Setting_outline_style_to_solid_and_double') }}</p>

<h3 id="Setting_outline_style_to_groove_and_ridge">Setting outline style to groove and ridge</h3>

<h4 id="HTML_4">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;div class="groove"&gt;
    &lt;p class="ridge"&gt;Outline Demo&lt;/p&gt;
  &lt;/div&gt;
&lt;/div&gt;</pre>

<h4 id="CSS_4">CSS</h4>

<pre class="brush: css notranslate">.groove {
  outline-style: groove;
}
.ridge {
  outline-style: ridge;
}

/* To make the Demo clearer */
* { outline-width: 10px; padding: 15px; }</pre>

<h4 id="Result_4">Result</h4>

<p>{{ EmbedLiveSample('Setting_outline_style_to_groove_and_ridge') }}</p>

<h3 id="Setting_outline_style_to_inset_and_outset">Setting outline style to inset and outset</h3>

<h4 id="HTML_5">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;div class="inset"&gt;
    &lt;p class="outset"&gt;Outline Demo&lt;/p&gt;
  &lt;/div&gt;
&lt;/div&gt;</pre>

<h4 id="CSS_5">CSS</h4>

<pre class="brush: css notranslate">.inset {
  outline-style: inset;
}
.outset {
  outline-style: outset;
}

/* To make the Demo clearer */
* { outline-width: 10px; padding: 15px; }</pre>

<h4 id="Result_5">Result</h4>

<p>{{ EmbedLiveSample('Setting_outline_style_to_inset_and_outset') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Basic UI', '#outline-style', 'outline-style')}}</td>
   <td>{{Spec2('CSS3 Basic UI')}}</td>
   <td>Added <code>auto</code> value.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'ui.html#propdef-outline-style', 'outline-style')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.outline-style")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("outline")}}</li>
 <li>{{cssxref("outline-color")}}</li>
 <li>{{cssxref("outline-width")}}</li>
</ul>
